Attribute VB_Name = "shortpaths"
Option Explicit

Public Sub ShortestPath(lFromNodeIndex As Long)
    
    Dim n As Long, u As Long, v As Long
    
    '#####################________Vorbereitung________#####################
    
    u = 0
    
    For n = 0 To lCountNodes - 1                            'alle Knoten warten
        dDistance(n) = cINFINITY                            'alle dDistance(n) = unendlich
    Next n
    
    dDistance(lFromNodeIndex) = 0                           'Distanz von Startknoten zu Startknoten = 0
    AddToList lFromNodeIndex
    v = lFromNodeIndex                                      'nchsten auf der Liste
    
    lTimeCounter = 0                                        'Zeitmessung beginnen
    frmshortpaths.tmrcalcduration.Enabled = True
    
    '#####################________Dijkstra-Algorithmus_Anfang________#####################
    
    Do Until v = -1                     'solange wartende Knoten da sind
    
        RemoveFromList v                'angehobenen Knoten von der Liste entfernen
        
        For u = 0 To lCountNodes - 1
        
            If Nodes(v).ConnectedToNode(u) Then
            'wenn v mit u verbunden ist, dann Knoten auf Warteliste und Distanz berechnen
                If dDistance(v) + Edges(Nodes(v).ConnectedOverEdge(u)).length < dDistance(u) Then
                    dDistance(u) = dDistance(v) + Edges(Nodes(v).ConnectedOverEdge(u)).length
                    lToNode(u) = v 'gehrt nicht zum Algortihmus, ist aber frs Abfahren erforderlich
                    AddToList u
                End If
            End If
            
        Next u
        DoEvents
        
        v = GetNextOnList()             'nchsten auf der Liste
        
    Loop
    
    '#####################________Dijkstra-Algorithmus_Ende________#####################
    
    frmshortpaths.tmrcalcduration.Enabled = False   'Zeitmessung beenden, Ergebnis anzeigen
    If lTimeCounter = 0 Then
        frmshortpaths.lblmessage.Caption = "Rechendauer: weniger als 1 Millisekunde"
    Else
        frmshortpaths.lblmessage.Caption = "Rechendauer: " & lTimeCounter & " Millisekunden"
    End If
    
    AktualiseDistanceLabels   'Distanzen anzeigen
    
    bShortestWaysReady = True    'bereit fr Abfahrt
    
End Sub
